/******************************************************************************/
//
// Name: 	Interfacing ADSP-21065L with AD7676 
//
/******************************************************************************

(C) Copyright 2004 - Analog Devices, Inc.  All rights reserved.

File Name:		ADSP-21065L_SerialPort_with_AD7676.asm

Date Modified:	08/19/04				Rev 1.0

Software:       VisualDSP++3.5 (July update)

Hardware:		ADSP-21065L EZ-KIT Lite

Purpose:		To receive data from AD7676
				
*******************************************************************************/

#include <def21065l.h>

#define FRAMED_MODE
//#define UNFRAMED_MODE

.section/dm seg_dmda;
	.var adc_data;
	.var counter = 0;

.section/pm seg_rth;
	nop;nop;nop;nop;
 	nop;jump start;

 // Sport receive interrupt
.section/pm seg_sp;
	nop;jump isr; rti;rti;
	
.section/pm seg_pmco;
start:
	// Configure TFS (CONVST) to be generated continuously
	r0 = 0x0;
	dm(STCTL0) = r0;

	r0 = 0xf0012;
	dm(TDIV0) = r0;
	
	r0 = DITFS | SPEN_A | SLEN32 | LTFS | ICLK | ITFS | TFSR ;
	dm(STCTL0) = r0;
	
	r0 = 0x12345678;
 	dm(TX0_A) = r0;

 	// Enable interrupts
	bit set mode1 IRPTEN;
	bit set imask SPR0I;
	 
	r0 = 0x0;
	dm(SRCTL0) = r0;
	
	r1 = 0x0;
	r7 = 0x2;
	
#ifdef UNFRAMED_MODE	
	r0 = SPEN_A|SLEN15|LRFS|LAFS|CKRE;
#endif
#ifdef FRAMED_MODE
	r0 = SPEN_A|SLEN15|LRFS|LAFS|RFSR|CKRE;
#endif
	dm(SRCTL0) = r0;
	
	nop;
	nop;
	jump(pc,0);
	
.section/pm seg_pmco;
isr:
	r3 = dm(RX0_A);

	// If it is the first word received, reconfigure the sport for
	// 16 bits
	r0 = dm(counter);
	comp(r0,r1);
	if eq jump reconfigure;
	
	// Incrementing the counter
	r6 = dm(counter);
	r6 = r6 + 1;
	dm(counter) = r6;
	
	comp(r6,r7);
	if eq rti;
	
	dm(adc_data) = r3;
	rti;

.section/pm seg_pmco;
reconfigure:
	// Reconfiguring the serial port for 16 bits.
#ifdef UNFRAMED_MODE
	r0 = SPEN_A|SLEN16|LRFS|LAFS|CKRE;
#endif
	
#ifdef FRAMED_MODE
	r0 = SPEN_A|SLEN16|LRFS|LAFS|RFSR|CKRE;
#endif
	dm(SRCTL0) = r0;
	
	r2 = 1;
	dm(counter) = r2;
	
	rti;
